#ifndef _GOSTC_ASYM_VKO_H_
#define _GOSTC_ASYM_VKO_H_

#include "gostc_asym.h"

#define GCVKO_ERROR_NUMOF_CSP		1
#define GCVKO_ERROR_LOADPARAMS		2
#define GCVKO_ERROR_EMPTYPOINTER	3
#define GCVKO_ERROR_GENSECRETKEY	4
#define GCVKO_ERROR_GENOPENKEY		5
#define GCVKO_ERROR_EMPTYSECRETKEY	6    
#define GCVKO_ERROR_EMPTYOPENKEY	7
#define GCVKO_ERROR_GENCOMMONKEY	8

#define GCVKO_MORE_RANDOM_DATA		100

#ifdef __cplusplus
extern "C" {
#endif


int gostc_vko_LoadParams(int paramset, void ** CSPstruct);
/* paramset: 1 - xchga, 2 - xchgb */
int gostc_vko_FreeParams(void * CSPstruct);

int gostc_vko_GenSecretKey(void *CSPstruct, uint8_t* rnd32b, void* SecretKey);
/* may return GCVKO_MORE_RANDOM_DATA */

int gostc_vko_GenOpenKey(void *CSPstruct, void* SecretKey, void *OpenKey);
int gostc_vko_GenCommonKey(void *CSPstruct, void * SecretKey, void * OpenKey,  
	void *UKM, void *CommonKey);

#ifdef __cplusplus
}
#endif

#endif

