#ifndef _GOSTC_COMMON_H_
#define _GOSTC_COMMON_H_

#define GOSTC_VERSION_MAJOR	1
#define GOSTC_VERSION_MINOR	6


#include <stdlib.h>
#include <string.h>

#ifdef WIN32 

#include <winsock.h>
/* Add Windows includes here */

typedef unsigned char	 uint8_t;
typedef char		 int8_t;
typedef unsigned short	 uint16_t;
typedef short		 int16_t;
typedef unsigned __int32 uint32_t;
typedef __int32		 int32_t;
typedef unsigned __int64 uint64_t;


#define bzero ZeroMemory
#define _wis_big_endian 0

#else /* Linux */

#include <stdint.h>
#include <strings.h>
#include <arpa/inet.h>
#include <sys/types.h> /* for endianess */

#ifndef _cdecl
#define _cdecl
#endif


#if __BYTE_ORDER == __LITTLE_ENDIAN

#define _wis_big_endian 0

#else /* big-endian (not supported) */

#define _wis_big_endian 1

#error "Big-endian is not supported yet"

#endif /* LITTLE_ENDIAN */

#endif /* !WIN32 */

/*#define GOSTC_ASYM_TEST_SPEED*/

/*Новые дефайны.*/
/*Размеры чисел в байтах*/
#define ASYM_DEF_SIZE 32 /*256-bit size numbers in bytes*/
#define ASYM_DEF_512_SIZE 64 /*512-bit size numbers in bytes*/

/*Количество "разрядов" точек в проективных координатах*/
#define ASYM_POINTSZ_256BIT 24 /*size of point in (X,Y,Z)-coord.*/
#define ASYM_POINTSZ_512BIT 48 /*size of point in (X,Y,Z)-coord.*/

/*Смещение по контексту 256-битных криптонаборов*/
#define ASYM_BASE_OFFSET ((ASYM_DEF_SIZE>>2)*6 + (ASYM_POINTSZ_256BIT)*4)*4

/*Размеры чисел в битах (кое-где нужно)*/
#define ASYM_BIT_SZ 	256
#define ASYM_BIT_512_SZ	512

#define ASYM_UKM16_SIZE		16 

/*Кол-во промежуточных буферов для вычислений
В данной версии используются с 1 по 11 и один зарезервирован
*/
#define ASYM_PROM_COUNT	13

#define ASYM_COUNTED_KPOINTS	256

/******Номера парамсетов для вычисления маски*********/
#define MASK_TSTGOST	0
#define MASK_CPROA	1
#define MASK_CPROB	2
#define MASK_CPROC	3
#define MASK_TST512	4
#define MASK_TC26A	5
#define MASK_TC26B	6

/*****Номера парамсетов для ЭЦП и ВКО*****************/

#define SIGN_TSTGOST	1
#define SIGN_CPROA	2
#define SIGN_CPROB	3
#define SIGN_CPROC	4
#define SIGN_TST512	5
#define SIGN_TC26A	6
#define SIGN_TC26B	7




#define ASYM_ELDER		0x80000000 /*Старший бит в слове*/
#define ASYM_MINUS_1	0xffffffff /*минус 1*/

#endif

