#include "gostc_mem.h"
#include "gostc_hash.h"
#include "gostc_hash_params.h"

/* #define TESTOUT */

#ifdef TESTOUT
#include <stdio.h> /* TESTOUT */
#endif


#define ZZ(x) bzero(x, sizeof(x))
#define ZZS(x) bzero(&x, sizeof(x))
#define SZZ(x) gostc_cleanse(x, sizeof(x))
#define SZZS(x) gostc_cleanse(&x, sizeof(x))


#define _lrotl(x,y) ((x<<(y))|(x>>(32-(y))))

typedef union 
{
 uint32_t l[8];
 uint8_t  c[32];
} LC;


typedef gostc_hash_ctx_t HSTRUC;

/*
static void hash_setUZ(uint8_t* shortUZ, uint32_t* longUZ)
{
	uint32_t oneElement;
	int i,j;

	for(i = 0;i<16;i++)
	{
	 for(j = 0;j<16;j++)
	  {
	    oneElement = (shortUZ[i*4]&0xf0)|(shortUZ[j*4]&0xf);
	    longUZ[i*16+j] = _lrotl(oneElement,11);

	    oneElement = (shortUZ[i*4+1]&0xf0)|(shortUZ[j*4+1]&0xf);
	    longUZ[256+i*16+j] = _lrotl(oneElement,(11+8));

	    oneElement = (shortUZ[i*4+2]&0xf0)|(shortUZ[j*4+2]&0xf);
	    longUZ[512+i*16+j] = _lrotl(oneElement,(11+16));

	    oneElement = (shortUZ[i*4+3]&0xf0)|(shortUZ[j*4+3]&0xf);
	    longUZ[768+i*16+j] = _lrotl(oneElement,(11+24-32));
	  }
	}
	oneElement = 0;
}*/

/*
static uint32_t htoll(uint32_t hostUSL)
{
	union {
		uint32_t val;
		char	buf[4];
	} p, r;

	if ( !_wis_big_endian ) return( hostUSL );

	p.val  = hostUSL;
	r.buf[0] = p.buf[3];
	r.buf[1] = p.buf[2];
	r.buf[2] = p.buf[1];
	r.buf[3] = p.buf[0];

	return( r.val );
}*/

static void ECB(uint32_t *AB,uint32_t *ABnew,uint32_t *key,uint32_t *SBlock)
{
  int i;
  uint32_t A,B,C;
  A = AB[1];
  B = AB[0];


  for(i = 0; i<8; i+=2)
  {
   C = B+key[i];
   A^=SBlock[C&0xffl];
   A^=SBlock[256+((C>>8)&0xffl)];
   A^=SBlock[512+((C>>16)&0xffl)];
   A^=SBlock[768+(C>>24)];
   C = A+key[i+1];
   B^=SBlock[C&0xffl];
   B^=SBlock[256+((C>>8)&0xffl)];
   B^=SBlock[512+((C>>16)&0xffl)];
   B^=SBlock[768+(C>>24)];
  }

  for(i = 0; i<8; i+=2)
  {
   C = B+key[i];
   A^=SBlock[C&0xff];
   A^=SBlock[256+((C>>8)&0xff)];
   A^=SBlock[512+((C>>16)&0xff)];
   A^=SBlock[768+(C>>24)];
   C = A+key[i+1];
   B^=SBlock[C&0xff];
   B^=SBlock[256+((C>>8)&0xff)];
   B^=SBlock[512+((C>>16)&0xff)];
   B^=SBlock[768+(C>>24)];
  }

  for(i = 0; i<8; i+=2)
  {
   C = B+key[i];
   A^=SBlock[C&0xff];
   A^=SBlock[256+((C>>8)&0xff)];
   A^=SBlock[512+((C>>16)&0xff)];
   A^=SBlock[768+(C>>24)];
   C = A+key[i+1];
   B^=SBlock[C&0xff];
   B^=SBlock[256+((C>>8)&0xff)];
   B^=SBlock[512+((C>>16)&0xff)];
   B^=SBlock[768+(C>>24)];
  }

  for(i = 6; i>=0; i-=2)
  {
   C = B+key[i+1];
   A^=SBlock[C&0xff];
   A^=SBlock[256+((C>>8)&0xff)];
   A^=SBlock[512+((C>>16)&0xff)];
   A^=SBlock[768+(C>>24)];
   C = A+key[i];
   B^=SBlock[C&0xff];
   B^=SBlock[256+((C>>8)&0xff)];
   B^=SBlock[512+((C>>16)&0xff)];
   B^=SBlock[768+(C>>24)];
  }

  ABnew[0] = A;
  ABnew[1] = B;

  SZZS(A);
  SZZS(B);
  SZZS(C);
}

/* uint32_t longUZ[1024]; */
/*
static void s_reg(uint16_t *r)
{
 if(_wis_big_endian)
  r[16] = r[1]^r[0]^r[3]^r[2]^r[11]^r[14];
 else
  r[16] = r[0]^r[1]^r[2]^r[3]^r[12]^r[15];
 return;
}
*/

static void plus(uint32_t *x,uint32_t *y,uint32_t *z)
{
 int i;
 for(i=0;i<8;i++)
  z[i] = x[i]^y[i];
}

/*
static void plus16(uint16_t *x,uint16_t *y,uint16_t *z)
{
 int i;
 for(i=0;i<16;i++)
  z[i] = x[i]^y[i];
}
*/

static void LongADD(void *a,void *b)
{
 uint32_t s = 0;
 uint16_t *a16 = (uint16_t*)a;
 uint16_t *b16 = (uint16_t*)b;
 int i;
 if(_wis_big_endian)
 {
  for(i=0;i<8;i+=2)
  {
   s = (uint32_t)a16[i+1]+(uint32_t)b16[i+1]+(s>>16);
   a16[i+1] = (uint16_t)s;
   s = (uint32_t)a16[i]+(uint32_t)b16[i]+(s>>16);
   a16[i] = (uint16_t)s;
  }
 }
 else
 {
  for(i = 0;i<16;i++)
  {
   s = (uint32_t)a16[i]+(uint32_t)b16[i]+(s>>16);
   a16[i] = (uint16_t)s;
  }
 }
 SZZS(s);
}

static void LongADD_1(void * a,uint32_t b)
{
 uint32_t bb[8];
 ZZ(bb);
 bb[0] = b;
 LongADD(a,bb);
 SZZ(bb);
}

#if 0

not used

static void reg (uint32_t *m, uint16_t *s,uint32_t *H)
{
 int i;
// uint32_t mP[8];
// uint32_t hP[8];
/* if(_wis_big_endian)
 {
  for(i = 0;i<8;i++)
  {
   mP[i] = htoll(m[i]);
   //hP[i] = htoll(H[i]);
  }
 }
*/ 
/*
if(_wis_big_endian)
    for(i = 0; i < 12; i++)
        S[16+i] = S[i]^S[1+i]^S[2+i]^S[3+i]
        ^S[12+i]^S[15+i];
else
    for(i = 0; i < 12; i+=2) {
        S[16+i+1] = S[i+1]^S[i]^S[3+i]^S.s[2+i]
        ^S[13+i]^S[14+i];
        S[16+i] = S[i]^S[3+i]^S[2+i]^S[5+i]
        ^S[12+i]^S[17+i];

    }
*/
/* if(_wis_big_endian)
  plus((uint32_t*)s,mP,(uint32_t*)s);
 else*/
  plus((uint32_t*)s,m,(uint32_t*)s);
 s_reg(s++);
 if(_wis_big_endian)
  plus16(s,(uint16_t*)H,s);
 else
  plus((uint32_t*)s,H,(uint32_t*)s);
/* if(_wis_big_endian)
 {
  for(i = 0;i<16;i+=2)
  {
   uint16_t s0;
   s0 = s[i];
   s[i] = s[i+1];
   s[i+1] = s0;
  }
 }*/
 for(i = 0;i<61;i++)
  s_reg (s++);
/* if(_wis_big_endian)
 {
   for(i=0;i<8;i++)
    H[i] = htoll(((uint32_t*)s)[i]);
 }
 else*/
 /*if(_wis_big_endian)
 {
  for(i = 0;i<16;i+=2)
  {
   uint16_t s0;
   s0 = s[i];
   s[i] = s[i+1];
   s[i+1] = s0;
  }
 } */
  memcpy(H,s,32); 
}
#endif

#define W(U, i, V, j)                           dwW[0] = U[i]  ^V[j];\
                                                dwW[1] = U[i+1]^V[j+1];\
                                                dwW[2] = U[i+2]^V[j+2];\
                                                dwW[3] = U[i+3]^V[j+3];\
                                                dwW[4] = U[i+4]^V[j+4];\
                                                dwW[5] = U[i+5]^V[j+5];\
                                                dwW[6] = U[i+6]^V[j+6];\
                                                dwW[7] = U[i+7]^V[j+7];

#define P(lpbW,K,p)               for(i = 0; i < 32; i++)\
                                                K[i] = *(lpbW + p[i])


static void KAPPA_1(void *M, void *H,void *UZ,void *C3)
{
	LC W, KEY;
	uint32_t U[32], V[24];
	uint32_t *Uptr = U, *Vptr = V;
	uint16_t S[90];
	int i;
 
	memcpy(U,H,32);
	memcpy(V,M,32);

 
	for (i = 0; i<8; i++) {
		W.l[i] = Vptr[i] ^ Uptr[i];
	}
	if (_wis_big_endian)
		P(W.c,KEY.c,gostc_hash_permut_be);
	else
		P(W.c,KEY.c,gostc_hash_permut);

	ECB((uint32_t*)H, (uint32_t*)S,KEY.l, (uint32_t*)UZ);
 
	Uptr[8] = Uptr[0] ^ Uptr[2];
	Uptr[9] = Uptr[1] ^ Uptr[3];
	Uptr += 2;
 
	Vptr[8] = Vptr[0] ^ Vptr[2];
	Vptr[9] = Vptr[1] ^ Vptr[3];
	Vptr += 2;
	Vptr[8] = Vptr[0] ^ Vptr[2];
	Vptr[9] = Vptr[1] ^ Vptr[3];
	Vptr += 2;
  
	for(i = 0; i<8; i++) {
		W.l[i] = Vptr[i]^Uptr[i];
	}

	if(_wis_big_endian)
		P(W.c,KEY.c, gostc_hash_permut_be);
	else
		P(W.c,KEY.c, gostc_hash_permut);

	ECB((uint32_t*)H+2, ((uint32_t*)S)+2, KEY.l, (uint32_t*)UZ);

	Uptr[8] = Uptr[0] ^ Uptr[2];
	Uptr[9] = Uptr[1] ^ Uptr[3];
	Uptr += 2;
 
	for(i = 0; i < 8; i++) {
		Uptr[i] ^= ((uint32_t*)C3)[i];
	}
 
	Vptr[8] = Vptr[0] ^ Vptr[2];
	Vptr[9] = Vptr[1] ^ Vptr[3];
	Vptr += 2;
	Vptr[8] = Vptr[0] ^ Vptr[2];
	Vptr[9] = Vptr[1] ^ Vptr[3];
	Vptr += 2;

	for (i = 0; i<8; i++) {
		W.l[i] = Vptr[i] ^ Uptr[i];
	}
	if (_wis_big_endian)
		P(W.c,KEY.c, gostc_hash_permut_be);
	else
		P(W.c,KEY.c, gostc_hash_permut);

	ECB((uint32_t*)H + 4, ((uint32_t*)S) + 4, KEY.l, (uint32_t*)UZ);

	Uptr[8] = Uptr[0] ^ Uptr[2];
	Uptr[9] = Uptr[1] ^ Uptr[3];
	Uptr += 2;
	Vptr[8] = Vptr[0] ^ Vptr[2];
	Vptr[9] = Vptr[1] ^ Vptr[3];
	Vptr += 2;
	Vptr[8] = Vptr[0] ^ Vptr[2];
	Vptr[9] = Vptr[1] ^ Vptr[3];
	Vptr += 2;

	for(i = 0; i<8; i++) {
		W.l[i] = Vptr[i] ^ Uptr[i];
	}

	if (_wis_big_endian)
		P(W.c,KEY.c, gostc_hash_permut_be);
	else
		P(W.c,KEY.c, gostc_hash_permut);

	ECB((uint32_t*)H + 6, ((uint32_t*)S) + 6, KEY.l, (uint32_t*)UZ);
 
	/* for(i = 0;i<12;i++)
	  s_reg(Sptr++);*/

	if(_wis_big_endian)
		for(i = 0; i < 12; i+=2) {
			S[16+i+1] = S[i+1] ^ S[i] ^ S[3+i] ^ S[2+i] ^ S[13+i] ^ S[14+i];
			S[16+i] = S[i] ^ S[3+i] ^ S[2+i] ^ S[5+i] ^ S[12+i] ^ S[17+i];
		}
	else
		for(i = 0; i < 12; i++)
			S[16+i] = S[i] ^ S[1+i] ^ S[2+i] ^ S[3+i] ^ S[12+i] ^ S[15+i];
	plus((uint32_t*)(S + 12),(uint32_t*)M,(uint32_t*)(S + 12));

	if(!_wis_big_endian)
		S[28] = S[12] ^ S[13] ^ S[14] ^ S[15] ^ S[24] ^ S[27];
	else
		S[29] = S[13] ^ S[12] ^ S[15] ^ S[14] ^ S[25] ^ S[26];

	/* H lpdwS = (LPDWORD)&usS[13];*/

	if(!_wis_big_endian)
		for(i = 0; i < 16; i++) {
			S[13 + i] ^= ((uint16_t*)H)[i];
		}
	else
		for(i = 0; i < 8; i++) {
		        /* *(lpdwS + i)^= *(lpdwHash + i); */
			S[12 + 2*i] ^= (uint16_t)(((uint32_t*)H)[i]);
			S[15 + 2*i] ^= (uint16_t)(((uint32_t*)H)[i] >> 16);
		}

	/* ????????? 61 ???? */
	if(!_wis_big_endian) {
		for(i = 0; i < 61; i++)
			S[29+i] = S[13+i] ^ S[14+i] ^ S[15+i] ^ S[16+i] ^ S[25+i] ^ S[28+i];
		memcpy(H,S+74,32);
	} else {
		for(i = 0; i < 60; i+=2) {
			S[28 + i] = S[12 + i] ^ S[15 + i] ^ S[14 + i] ^ S[17 + i] ^ S[24 + i] 
				^ S[29 + i];
			S[31 + i] = S[15 + i] ^ S[14 + i] ^ S[17 + i] ^ S[16 + i] ^ S[27 + i]
				^ S[28 + i];
		}
		S[28 + 60] = S[12 + 60] ^ S[15 + 60] ^ S[14 + 60] ^ S[17 + 60] ^ S[24 + 60]
			^ S[29 + 60];
		memcpy(H, S + 74, 32);
	}

	SZZS(W);
	SZZS(KEY);
	SZZ(U);
	SZZ(V);
	SZZ(S);
}
/****************************************************************************/
void gostc_hash_clear(gostc_hash_ctx_t* ctx)
{
	if (!ctx) return;
	gostc_cleanse(ctx, sizeof(gostc_hash_ctx_t));
}
/****************************************************************************/
void gostc_hash_reset(gostc_hash_ctx_t* ctx)
{
	if (!ctx) return;
	bzero(ctx, sizeof(gostc_hash_ctx_t));
/*	hash_setUZ((unsigned char*)hash_uz_cpro, ctx->longUZ); */
	ctx->longUZ = gostc_hash_uz_cpro_long;
}
/****************************************************************************/
void * gostc_hash_open(void)
{
	HSTRUC *hs;

	hs = (HSTRUC*) gostc_malloc(sizeof(HSTRUC));
	if (!hs) return NULL;
/*	bzero(hs, sizeof(HSTRUC)); - already zeroed by gostc_malloc */
/*	hash_setUZ((unsigned char*)hash_uz_cpro, hs->longUZ); */
	hs->longUZ = gostc_hash_uz_cpro_long;
	return hs;
}

#ifndef min
#define min(a,b) ((a<b)?a:b)
#endif

/****************************************************************************/
void gostc_hash_do(void* vhs, const void* buf, int l)
{
	HSTRUC *hs = (HSTRUC*)vhs;
	uint32_t M[8];
	int i;
	int rest;
	
	if (!vhs || !buf || !l) return;
 
	if (hs->count) {
		rest = min(32 - hs->count, l);
		memcpy(hs->R + hs->count, buf, rest);
		hs->count += rest; 
		l -= rest;
		if (hs->count < 32) return;

		for(i = 0; i < 8; i++) {
			M[i] = /*htoll*/ ((uint32_t*)hs->R)[i]; /* fix for BigEndian */
		}
		KAPPA_1(M, hs->H, hs->longUZ, gostc_hash94_C3);
		LongADD_1(hs->L, 256L);
		LongADD(hs->SIGMA, M);
		buf = ((char*)buf) + rest;
		hs->count = 0;
	}
	while (l >= 32) {
		for(i = 0; i < 8; i++) {
			M[i] = /*htoll*/ ((uint32_t*)buf)[i]; /* fix for BigEndian */
		}
		KAPPA_1(M,hs->H, hs->longUZ, gostc_hash94_C3);
		LongADD_1(hs->L,256L);
		LongADD(hs->SIGMA,M);
		buf = ((uint8_t*)buf) + 32;
		l-=32;
	}
	if(l) {
		memcpy(hs->R,buf,l);
	}
	hs->count = l;
	SZZ(M);
}
/****************************************************************************/
void gostc_hash_close(void* vhs, void* hash)
{
	if (!vhs) {
		if (hash) bzero(hash, 32); /* hash=0 if error */
		return;
	}
	gostc_hash_close_plain((gostc_hash_ctx_t*)vhs, hash);
/*	bzero(hs, sizeof(HSTRUC)); - zeroed by gostc_hash_close_plain */
	gostc_free(vhs);
}
/****************************************************************************/
void gostc_hash_close_plain(gostc_hash_ctx_t* ctx, void* hash)
{
	uint32_t M[8];
	int i;

	if (!ctx) {
		if (hash) bzero(hash, 32); /* hash=0 if error */
		return;
	}
	if (!hash) {
		gostc_cleanse(ctx, sizeof(gostc_hash_ctx_t));
		return;
	}
	if(ctx->count) {
		bzero(ctx->R + ctx->count, 32 - ctx->count);
		for (i = 0; i < 8; i++)	{
			M[i] = /*htoll*/((uint32_t*)ctx->R)[i]; /* fix for BigEndian */
		}
		KAPPA_1(M, ctx->H, ctx->longUZ, gostc_hash94_C3);
		LongADD_1(ctx->L, ((int32_t)ctx->count) << 3);
		LongADD(ctx->SIGMA, M);
	}
	KAPPA_1(ctx->L,ctx->H, ctx->longUZ, gostc_hash94_C3);
	KAPPA_1(ctx->SIGMA, ctx->H, ctx->longUZ, gostc_hash94_C3);
	memcpy(hash, ctx->H, 32);
	SZZ(M);
	gostc_cleanse(ctx, sizeof(gostc_hash_ctx_t));
	/* ctx remains not freed, invalid, but cleared */
}
/****************************************************************************/
void* gostc_hmac_open(void* key, int keylen)
{
	uint8_t key2[32];
	HSTRUC* hh;
	int i;

	if ((!key && keylen) || keylen < 0) return NULL;
	ZZ(key2);
	if (keylen) {
		if (keylen < 33) memcpy(key2, key, keylen);
		else {
			hh = (HSTRUC*)gostc_hash_open();
			gostc_hash_do(hh, key, keylen);
			gostc_hash_close(hh, key2);
		}
	}
	hh = (HSTRUC*)gostc_hash_open();
	memcpy(hh->hmackey, key2, 32);
	for (i = 0; i < 32; i++) key2[i] ^= 0x36;
	gostc_hash_do(hh, key2, 32);
	SZZ(key2);
	return hh;
}
/****************************************************************************/
void gostc_hmac_do(void* hhandle, void* data, int len)
{
	if (!hhandle || !data || len < 1) return;
	gostc_hash_do(hhandle, data, len);
}
/****************************************************************************/
void gostc_hmac_close(void* hhandle, void* hmac)
{
	uint8_t key2[32];
	HSTRUC* hh = (HSTRUC*)hhandle;
	uint8_t hash[32];
	int i;

	if (!hhandle) return;
	if (!hmac) {
/*		bzero(hhandle, sizeof(HSTRUC)); - zeroed by gostc_free */
		gostc_free(hhandle);
		return;
	}
	memcpy(key2, hh->hmackey, 32);
	gostc_hash_close(hhandle, hash);
	for (i = 0; i < 32; i++) key2[i] ^= 0x5C;
	hhandle = gostc_hash_open();
	if (!hhandle) {
		SZZ(key2);
		SZZ(hash);
		return;
	}
	gostc_hash_do(hhandle, key2, 32);
	gostc_hash_do(hhandle, hash, 32);
	SZZ(key2);
	SZZ(hash);
	gostc_hash_close(hhandle, hmac);
}
/****************************************************************************/

/*
static void MakeMatr(gostc_hash12_ctx_t *hs)
{
	int i,j;
	uint64_t A2[64];/ *Локальня копия матрицы - чтобы не "убить" основную* /
	for(i=0;i<64;i++)
		A2[i] = A[i];

	for(i=0;i<64;i++)
	for(j=0;j<16;j++) {
		hs->Amatr[i][j] = (uint8_t)(A2[i]&0x000000000000000f);
		A2[i] = A2[i]>>4;
	}
}

static void precalc_mul_table(gostc_hash12_ctx_t *hs)
{
	uint64_t Aback[64],t;
	uint8_t p;
	int i,j,k;
	for(i=0;i<64;i++)
		Aback[63-i] = gostc_hash_AMatr[i];
	for(i=0;i<8;i++)
		for(j=0;j<256;j++)
		{
			t = 0;
			p = gostc_hash_Pi1[j];
			for(k=0;k<8;k++)
				if(p&(1<<k))
					t ^= Aback[(i<<3)|k];
			hs->mul_table[i][j] = t;
		}
}
*/

static void Add_old_1_onhclose(uint32_t *m, uint32_t L)
{
	uint8_t *b;
	b = (uint8_t*)m;
	b[L] = 1;
	return;
}


static void add_64(uint32_t *s1,uint32_t*s2,uint32_t * sum)
{
	uint64_t prom;
	int i;
	prom = 0;
	for(i=0;i<16;i++)
	{
		prom = prom + s1[i];
		prom += s2[i];
		sum[i] = (uint32_t)prom;
		prom = prom >> 32;
	}
	SZZS(prom);

}

static void Mod64(uint32_t *s1, uint32_t *s2, uint32_t *rez)
{
	int i;
	for(i=0;i<16;i++)
		rez[i] = s1[i] ^ s2[i];

}

static void lps(uint64_t* out,const uint8_t* in)
{
	int i;
	uint64_t t;
	for(i=0;i<8;i++)
	{
		t = gostc_hash_MulTable[0][in[i]];
		t ^= gostc_hash_MulTable[1][in[i+1*8]];
		t ^= gostc_hash_MulTable[2][in[i+2*8]];
		t ^= gostc_hash_MulTable[3][in[i+3*8]];
		t ^= gostc_hash_MulTable[4][in[i+4*8]];
		t ^= gostc_hash_MulTable[5][in[i+5*8]];
		t ^= gostc_hash_MulTable[6][in[i+6*8]];
		t ^= gostc_hash_MulTable[7][in[i+7*8]];
		out[i] = t;
	}
	SZZS(t);
}


static void OperLPS(uint32_t *src, uint64_t *result)
{
	
	bzero(result,64);
	lps(result,(uint8_t*)src);
	
	
}

static void GNHash(gostc_hash12_ctx_t* hs, uint32_t* hsrc, uint32_t *m, uint32_t *len_osn, 
	uint32_t *hrez)
{
	uint32_t pr[16],pr2[16];
	
	
	ZZ(pr);
	ZZ(pr2);
	
	memcpy(hs->pr,m,64);
	Mod64(len_osn,hsrc,pr);
	OperLPS(pr,hs->K[1]);
	
	Mod64((uint32_t*)hs->K[1],(uint32_t*)hs->pr,pr); 
	OperLPS(pr,hs->K[0]);

	Mod64((uint32_t*)hs->K[1],gostc_hash_C1,pr);
	OperLPS(pr,hs->K[2]); 

	Mod64((uint32_t*)hs->K[2],(uint32_t*)hs->K[0],pr);
	OperLPS(pr,hs->K[0]);
	Mod64((uint32_t*)hs->K[2],gostc_hash_C2,pr);
	OperLPS(pr,hs->K[3]);

	Mod64((uint32_t*)hs->K[3],(uint32_t*)hs->K[0],pr);
	OperLPS(pr,hs->K[0]); 
	Mod64((uint32_t*)hs->K[3],gostc_hash_C3,pr);
	OperLPS(pr,hs->K[4]); 
	
	Mod64((uint32_t*)hs->K[4],(uint32_t*)hs->K[0],pr);
	OperLPS(pr,hs->K[0]); 
	Mod64((uint32_t*)hs->K[4],gostc_hash_C4,pr);
	OperLPS(pr,hs->K[5]);

	Mod64((uint32_t*)hs->K[5],(uint32_t*)hs->K[0],pr);
	OperLPS(pr,hs->K[0]); 
	Mod64((uint32_t*)hs->K[5],gostc_hash_C5,pr);
	OperLPS(pr,hs->K[6]);

	Mod64((uint32_t*)hs->K[6],(uint32_t*)hs->K[0],pr);
	OperLPS(pr,hs->K[0]); 
	Mod64((uint32_t*)hs->K[6],gostc_hash_C6,pr);
	OperLPS(pr,hs->K[7]); 

	Mod64((uint32_t*)hs->K[7],(uint32_t*)hs->K[0],pr);
	OperLPS(pr,hs->K[0]); 
	Mod64((uint32_t*)hs->K[7],gostc_hash_C7,pr);
	OperLPS(pr,hs->K[8]); 

	Mod64((uint32_t*)hs->K[8],(uint32_t*)hs->K[0],pr);
	OperLPS(pr,hs->K[0]); 
	Mod64((uint32_t*)hs->K[8],gostc_hash_C8,pr);
	OperLPS(pr,hs->K[9]);

	Mod64((uint32_t*)hs->K[9],(uint32_t*)hs->K[0],pr);
	OperLPS(pr,hs->K[0]);
	Mod64((uint32_t*)hs->K[9],gostc_hash_C9,pr);
	OperLPS(pr,hs->K[10]);

	Mod64((uint32_t*)hs->K[10],(uint32_t*)hs->K[0],pr);
	OperLPS(pr,hs->K[0]);
	Mod64((uint32_t*)hs->K[10],gostc_hash_C10,pr);
	OperLPS(pr,hs->K[11]);

	Mod64((uint32_t*)hs->K[11],(uint32_t*)hs->K[0],pr);
	OperLPS(pr,hs->K[0]);
	Mod64((uint32_t*)hs->K[11],gostc_hash_C11,pr);
	OperLPS(pr,hs->K[12]); 

	Mod64((uint32_t*)hs->K[12],(uint32_t*)hs->K[0],pr);
	OperLPS(pr,hs->K[0]); 
	Mod64((uint32_t*)hs->K[12],gostc_hash_C12,pr);
	OperLPS(pr,hs->K[13]); 

	Mod64((uint32_t*)hs->K[13],(uint32_t*)hs->K[0],pr);
	
	Mod64(pr,(uint32_t*)hs->pr,pr2);
	Mod64(pr2,hsrc,hrez);

	SZZ(pr);
	SZZ(pr2);
}
/*****************************************************************************/
gostc_hash12_ctx_t* gostc_hash12_new()
{
	return malloc(sizeof(gostc_hash12_ctx_t));
}
/*****************************************************************************/
int gostc_hash12_init(gostc_hash12_ctx_t* ctx, int mode256)
{
	int i;

	if (!ctx) return 1;

	bzero(ctx, sizeof(gostc_hash12_ctx_t));
	ctx->mode256 = mode256 ? 1 : 0 ;

	if (mode256) {
		for(i=0;i<16;i++)
			ctx->H[i] = 0x01010101; 
	}
/*	precalc_mul_table(ctx); */
/*	MakeMatr(ctx); */
	return 0;
}
/*****************************************************************************/
int gostc_hash12_do(gostc_hash12_ctx_t* hs, void *buf_in, unsigned int size)
{
	uint32_t iterMatr[16];
	uint8_t *buf;

	if (!hs || !buf_in) return 1;
	if (!size) return 0;
	hs->to_clear = 1;
	ZZ(iterMatr);
	iterMatr[0] = 512;
	buf = (uint8_t*)buf_in;
	
	if(hs->tailSZ) {	
		if(size < (64 - hs->tailSZ))  {
			memcpy((uint8_t*)hs->M + hs->tailSZ, buf, size);
			hs->tailSZ += size;
			goto end;
		} else {
			memcpy((uint8_t*)hs->M + hs->tailSZ, buf, 64-hs->tailSZ);
			
			GNHash(hs, hs->H, hs->M, hs->N, hs->H);
			add_64(hs->N, iterMatr, hs->N);
			add_64(hs->Eps, hs->M, hs->Eps);
			buf = buf + 64 - hs->tailSZ;
			size -= 64 - hs->tailSZ;
			hs->tailSZ = 0; /* Занулить! Иначе мог остаться хвост там где не надо */
		}
	}
	while(size >= 64) {
		memcpy(hs->M, buf, 64);
		
		GNHash(hs, hs->H, hs->M, hs->N, hs->H);
			
		add_64(hs->N,iterMatr,hs->N);
		add_64(hs->Eps,hs->M,hs->Eps);
		buf += 64;
		size -= 64;
	}
	bzero(hs->M,64);
	if(size)
	{
		memcpy(hs->M, buf, size);
		hs->tailSZ = size;
	}
end:
	SZZ(iterMatr);
	return 0;
}
/*****************************************************************************/
int gostc_hash12_finish(gostc_hash12_ctx_t* hs, void* hash)
{
	uint32_t zero[16],pr[16];
	uint64_t ppp;

	if (!hs || !hash) return 1;

	ZZ(zero);
	ZZ(pr);

	Add_old_1_onhclose(hs->M, hs->tailSZ);
	GNHash(hs, hs->H, hs->M, hs->N, hs->H);
	
	ppp = (uint64_t)(hs->N[0]) + hs->tailSZ * 8;
	hs->N[0] = (uint32_t)ppp;
	hs->N[1] += (uint32_t)(ppp >> 32);
	/*hs->N[0] += hs->tailSZ*8;  - Это было не совсем верно (Иван)*/

	add_64(hs->Eps, hs->M, pr);
	memcpy(hs->Eps, pr, 64);

	GNHash(hs, hs->H, hs->N, zero, hs->H);

	/*shag  3.6 */
	GNHash(hs, hs->H, (uint32_t*)hs->Eps, zero, hs->H);

	if(hs->mode256) memcpy(hash, hs->H + 8, 32);
	else memcpy(hash, hs->H, 64);

	SZZ(pr);
	SZZS(ppp);

	return 0;
}
/*****************************************************************************/
void gostc_hash12_clear(gostc_hash12_ctx_t* ctx)
{
	if (!ctx) return;
	gostc_cleanse(ctx, sizeof(gostc_hash12_ctx_t));
	ctx->to_clear = 0;
}
/*****************************************************************************/
void gostc_hash12_free(gostc_hash12_ctx_t** pctx)
{
	gostc_hash12_ctx_t* ctx;

	if (!pctx) return;
	ctx = *pctx;
	*pctx = NULL;
	if (!ctx) return; 
	if (ctx->to_clear) gostc_hash12_clear(ctx);
	free(ctx);
}
/*****************************************************************************/
int gostc_hash12_test(void)
{
	uint32_t hashT[16];
	int i;
	int ret = 1;
	gostc_hash12_ctx_t* h = NULL;
	int rc = 1;
	
	for(i=0;i<16;i++)
		hashT[i] = 0;
	
	/* test 512-bit  */
	h = gostc_hash12_new();
	if (h) ret = gostc_hash12_init(h, 0);
	if(!h || ret) {
#ifdef TESTOUT
		printf("failed to open HASH2012\n");
#endif
		rc = 2;
		goto end;
	}
	ret = gostc_hash12_do(h, gostc_hash_M, gostc_hash_sizeM);
	if (ret) {
#ifdef TESTOUT
		printf("Error in DoHash\n");
#endif
		rc = 3;
		goto end;
	}
	ret = gostc_hash12_finish(h, hashT);
	if(ret) {
#ifdef TESTOUT
		printf("Error in Hclosse\n");
#endif
		rc = 4;
		goto end;
	}
#ifdef TESTOUT
	printf("HASH2012 - etalon --- count:\n");
	for(i=0;i<8;i++)
		printf("0x%8.8x,0x%8.8x, ---  0x%8.8x, 0x%8.8x\n",hash512_1[i*2],hash512_1[i*2+1],hashT[i*2],hashT[i*2+1]);
#endif
	if(memcmp(gostc_hash_hash512_1, hashT, 64) != 0) { rc = 5; goto end; }
	
	ret = gostc_hash12_init(h, 0);
	if(ret) {
#ifdef TESTOUT
		printf("failed to open HASH2012\n");
#endif
		rc = 6;
		goto end;
	}
	ret = gostc_hash12_do(h, gostc_hash_M2, gostc_hash_sizeM2);
	if(ret) {
#ifdef TESTOUT
		printf("Error in DoHash\n");
#endif
		rc = 7;
		goto end;
	}
	ret = gostc_hash12_finish(h, hashT);
	if(ret) {
#ifdef TESTOUT
		printf("Error in Hclosse\n");
#endif
		rc = 8;
		goto end;
	}
#ifdef TESTOUT
	printf("HASH2012 - etalon --- count:\n");
	for(i = 0; i < 8; i++)
		printf("0x%8.8x,0x%8.8x, ---  0x%8.8x, 0x%8.8x\n",hash512_2[i*2],hash512_2[i*2+1],hashT[i*2],hashT[i*2+1]);
#endif
	if(memcmp(gostc_hash_hash512_2, hashT, 64) != 0) { rc = 9; goto end; }
	
	/*test 256-bit */
	ZZ(hashT);
	ret = gostc_hash12_init(h, 1);
	if(ret) {
#ifdef TESTOUT
		printf("failed to open HASH2012\n");
#endif
		rc = 10;
		goto end;
	}
	ret = gostc_hash12_do(h, gostc_hash_M, gostc_hash_sizeM);
	if (ret) {
#ifdef TESTOUT
		printf("Error in DoHash\n");
#endif
		rc = 11;
		goto end;
	}
	ret = gostc_hash12_finish(h, hashT);
	if(ret) {
#ifdef TESTOUT
		printf("Error in Hclose\n");
#endif
		rc = 12;
		goto end;
	}
#ifdef TESTOUT
	printf("HASH2012 - etalon --- count:\n");
	for(i=0;i<4;i++)
		printf("0x%8.8x,0x%8.8x, ---  0x%8.8x, 0x%8.8x\n",hash256_1[i*2],hash256_1[i*2+1],hashT[i*2],hashT[i*2+1]);
#endif
	if(memcmp(gostc_hash_hash256_1, hashT, 32)!=0) { rc = 13; goto end; }
	rc = 0;
end:
	if (h) {
		gostc_hash12_clear(h);
		gostc_hash12_free(&h);
	}
	return rc;
}
/*****************************************************************************/
int gostc_hmac12_init(gostc_hmac12_ctx_t* ctx, void* key, unsigned int keylen)
{
	uint8_t key2[64];
	int i;
	int rc = 1;

	if (!ctx || (!key && keylen)) return 1;

	ZZ(key2);
	if (keylen) {
		if (keylen < 65) memcpy(key2, key, keylen);
		else {
			if (gostc_hash12_init(ctx, 0)) goto end; 
			if (gostc_hash12_do(ctx, key, keylen)) goto end; 
			if (gostc_hash12_finish(ctx, key2)) goto end;
		}
	}
	if (gostc_hash12_init(ctx, 0)) goto end;
	memcpy(ctx->hmackey, key2, 64);
	for (i = 0; i < 64; i++) key2[i] ^= 0x36;
	if (gostc_hash12_do(ctx, key2, 64)) goto end; 
	rc = 0;
end:
	SZZ(key2);
	return rc;
}
/*****************************************************************************/
int gostc_hmac12_finish(gostc_hmac12_ctx_t* ctx, void* hmac)
{
	uint8_t key2[64];
	uint8_t hash[64];
	int i;
	int rc = 1;

	if (!ctx || !hmac) return 1;

	memcpy(key2, ctx->hmackey, 64);
	if (gostc_hash12_finish(ctx, hash)) goto end;
	for (i = 0; i < 64; i++) key2[i] ^= 0x5C;
	if (gostc_hash12_init(ctx, 0)) goto end;
	if (gostc_hash12_do(ctx, key2, 64)) goto end; 
	if (gostc_hash12_do(ctx, hash, 64)) goto end; 
	if (gostc_hash12_finish(ctx, hmac)) goto end;
	rc = 0;
end:
	SZZ(key2);
	SZZ(hash);
	return rc;
}
/*****************************************************************************/

