#include "gostc_hash.h"
#include <stdio.h>
#include <stdint.h>
#include <string.h>
#include <strings.h>


char Str[]="Suppose the original message has length = 50 bytes";
uint8_t Hash[32] = { 
	0xc3, 0x73, 0x0c, 0x5c, 0xbc, 0xca, 0xcf, 0x91, 0x5a, 0xc2, 
	0x92, 0x67, 0x6f, 0x21, 0xe8, 0xbd, 0x4e, 0xf7, 0x53, 0x31, 
	0xd9, 0x40, 0x5e, 0x5f, 0x1a, 0x61, 0xdc, 0x31, 0x30, 0xa6, 
	0x50, 0x11
};

char Str2[] = "This is message, length=32 bytes";

uint8_t HK[32] = {
	0x73, 0x3d, 0x2c, 0x20, 0x65, 0x68, 0x65, 0x73, 0x74, 0x74, 
	0x67, 0x69, 0x79, 0x67, 0x61, 0x20, 0x62, 0x6e, 0x73, 0x73, 
	0x20, 0x65, 0x73, 0x69, 0x32, 0x6c, 0x65, 0x68, 0x33, 0x20, 
	0x6d, 0x54
};

uint8_t HMAC[32] = { 
	0x4f, 0xf6, 0x6c, 0x94, 0xbd, 0xda, 0xae, 0x61, 0x13, 0x36, 
	0x05, 0x14, 0x2b, 0x58, 0x2b, 0x9c, 0x0f, 0x38, 0xbb, 0xdf, 
	0xf3, 0xd7, 0xf0, 0xee, 0x6a, 0x9c, 0x93, 0x5d, 0x92, 0xbf, 
	0xa1, 0x07
};

uint8_t Str3[72] = {
	0xd1, 0xe5, 0x20, 0xe2, 0xe5, 0xf2, 0xf0, 0xe8, 0x2c, 0x20, 
	0xd1, 0xf2, 0xf0, 0xe8, 0xe1, 0xee, 0xe6, 0xe8, 0x20, 0xe2, 
	0xed, 0xf3, 0xf6, 0xe8, 0x2c, 0x20, 0xe2, 0xe5, 0xfe, 0xf2, 
	0xfa, 0x20, 0xf1, 0x20, 0xec, 0xee, 0xf0, 0xff, 0x20, 0xf1, 
	0xf2, 0xf0, 0xe5, 0xeb, 0xe0, 0xec, 0xe8, 0x20, 0xed, 0xe0, 
	0x20, 0xf5, 0xf0, 0xe0, 0xe1, 0xf0, 0xfb, 0xff, 0x20, 0xef, 
	0xeb, 0xfa, 0xea, 0xfb, 0x20, 0xc8, 0xe3, 0xee, 0xf0, 0xe5, 
	0xe2, 0xfb
};

uint8_t Hash12[64] = {
	0x1e, 0x88, 0xe6, 0x22, 0x26, 0xbf, 0xca, 0x6f, 0x99, 0x94, 
	0xf1, 0xf2, 0xd5, 0x15, 0x69, 0xe0, 0xda, 0xf8, 0x47, 0x5a, 
	0x3b, 0x0f, 0xe6, 0x1a, 0x53, 0x00, 0xee, 0xe4, 0x6d, 0x96, 
	0x13, 0x76, 0x03, 0x5f, 0xe8, 0x35, 0x49, 0xad, 0xa2, 0xb8, 
	0x62, 0x0f, 0xcd, 0x7c, 0x49, 0x6c, 0xe5, 0xb3, 0x3f, 0x0c, 
	0xb9, 0xdd, 0xdc, 0x2b, 0x64, 0x60, 0x14, 0x3b, 0x03, 0xda, 
	0xba, 0xc9, 0xfb, 0x28
};

uint8_t Str4[63] = {
	0x30, 0x31, 0x32, 0x33, 0x34, 0x35, 0x36, 0x37, 0x38, 0x39, 
	0x30, 0x31, 0x32, 0x33, 0x34, 0x35, 0x36, 0x37, 0x38, 0x39, 
	0x30, 0x31, 0x32, 0x33, 0x34, 0x35, 0x36, 0x37, 0x38, 0x39, 
	0x30, 0x31, 0x32, 0x33, 0x34, 0x35, 0x36, 0x37, 0x38, 0x39, 
	0x30, 0x31, 0x32, 0x33, 0x34, 0x35, 0x36, 0x37, 0x38, 0x39, 
	0x30, 0x31, 0x32, 0x33, 0x34, 0x35, 0x36, 0x37, 0x38, 0x39, 
	0x30, 0x31, 0x32
};

uint8_t Hash12_256[32] = {
	0x9d, 0x15, 0x1e, 0xef, 0xd8, 0x59, 0x0b, 0x89, 0xda, 0xa6, /*//10*/
	0xba, 0x6c, 0xb7, 0x4a, 0xf9, 0x27, 0x5d, 0xd0, 0x51, 0x02, /*//20*/
	0x6b, 0xb1, 0x49, 0xa4, 0x52, 0xfd, 0x84, 0xe5, 0xe5, 0x7b, /*//30*/
	0x55, 0x00
};

int main(int argc, char** argv)
{
	uint8_t b32[32];
	uint8_t b64[64];
	void *h = NULL;
	gostc_hash12_ctx_t* h12 = NULL;
	int rc = 1;
	int n = 33;
	int rc2 = 0;

	bzero(b32, 32);
	h = gostc_hash_open();
	if (!h) {
		printf("Failed to open hash\n");
		return 1;
	}
	gostc_hash_do(h, Str, strlen(Str));
	gostc_hash_close(h, b32);
	h = NULL;
	if (memcmp(b32, Hash, 32)) { goto end; }

	printf("Test2\n");
	for (n = 0; n < strlen(Str) + 1; n++)  
	{ 
		printf("n=%d\n", n);
		h = gostc_hash_open();
		if (!h) {
			printf("Failed to open hash\n");
			goto end;
		}
		gostc_hash_do(h, Str, n);
		gostc_hash_do(h, Str + n, strlen(Str) - n);
		gostc_hash_close(h, b32);
		h = NULL;
		if (memcmp(b32, Hash, 32)) { goto end; }
	}

	printf("HMAC test: \n");

	for (n = 0; n < strlen(Str2) + 1; n++) { 
		printf("n=%d\n", n);
		h = gostc_hmac_open(HK, 32);
		if (!h) {
			printf("Failed to open hmac\n");
			goto end;
		}
		gostc_hmac_do(h, Str2, n);
		gostc_hmac_do(h, Str2 + n, strlen(Str2) - n);
		gostc_hmac_close(h, b32);
		h = NULL;
		if (memcmp(b32, HMAC, 32)) { goto end; }
	}

	printf("TEST GOST-HASH2012:\n");
	rc2 = gostc_hash12_test();
	if (!rc2) printf("Correct!\n");
	else {
		printf("Failed! Code=%d\n", rc2);
		goto end;
	}
	
	printf("Hash 2012 - same test by Vova:\n");
	h12 = gostc_hash12_new();
	if (h12) rc2 = gostc_hash12_init(h12, 0);
	if (!h12 || rc2) {
		printf("Failed to open hash.\n");
		goto end;
	}
	if (gostc_hash12_do(h12, Str3, sizeof(Str3))) {
		printf("Failed to calc hash.\n");
		goto end;
	}
	if (gostc_hash12_finish(h12, b64)) {
		printf("Failed to close hash.\n");
		goto end;
	}
	if (memcmp(b64, Hash12, 64)) goto end;


	printf("Hash 2012 more strict test:\n");

	for (n = 0; n < sizeof(Str3) + 1; n++) {
		printf("n=%d\n", n);
		rc2 = gostc_hash12_init(h12, 0);
		if (rc2) {
			printf("Failed to open hash\n");
			goto end;
		}
		if (gostc_hash12_do(h12, Str3, n)) { printf("err:do 1\n"); goto end; }
		if (gostc_hash12_do(h12, Str3 + n, sizeof(Str3) - n)) {
			printf("err:do 2\n"); 
			goto end;
		}
		if (gostc_hash12_finish(h12, b64)) { printf("err:close\n"); goto end; }
		if (memcmp(b64, Hash12, 64)) { goto end; }
	}



	printf("Hash 2012-256 strict test:\n");

	for (n = 0; n < sizeof(Str4) + 1; n++) {
		printf("n=%d\n", n);
		rc2 = gostc_hash12_init(h12, 1);
		if (rc2) {
			printf("Failed to open hash\n");
			goto end;
		}
		if (gostc_hash12_do(h12, Str4, n)) { printf("err:do 1\n"); goto end; }
		if (gostc_hash12_do(h12, Str4 + n, sizeof(Str4) - n)) {
			printf("err:do 2\n"); 
			goto end;
		}
		if (gostc_hash12_finish(h12, b32)) { printf("err:close\n"); goto end; }
		if (memcmp(b32, Hash12_256, 32)) { goto end; }
	}

	rc = 0;
end:
	gostc_hash_close(h, NULL);
	gostc_hash12_clear(h12);
	gostc_hash12_free(&h12);
	if (rc) {
		printf("TEST FAILED\n");
		return 1;
	}
	printf("TEST PASSED\n");
	return 0;
}

