#include <stdio.h>
#include "gostc_hash.h"


uint8_t HashIn[] = {
	0x46, 0x57, 0x45, 0x45, 0x41, 0x59, 0x44, 0x52, 0x36, 0x36, 
	0x36, 0x36, 0x36, 0x36, 0x36, 0x36, 0x36, 0x36, 0x36, 0x36, 
	0x36, 0x36, 0x36, 0x36, 0x36, 0x36, 0x36, 0x36, 0x36, 0x36, 
	0x36, 0x36, 0x36, 0x36, 0x36, 0x36, 0x36, 0x36, 0x36, 0x36, 
	0x36, 0x36, 0x36, 0x36, 0x36, 0x36, 0x36, 0x36, 0x36, 0x36, 
	0x36, 0x36, 0x36, 0x36, 0x36, 0x36, 0x36, 0x36, 0x36, 0x36, 
	0x36, 0x36, 0x36, 0x36, 0x73, 0x61, 0x6c, 0x74, 0x00, 0x00, 
	0x00, 0x01
};

uint8_t HashOut[64] = { 
/* Should be swapped. Infotecs had error */
	0xf2, 0x2d, 0x14, 0xbc, 0xa3, 0x86, 0xcd, 0x72, 0xf5, 0xe2, 
	0xd2, 0x0a, 0x25, 0xa5, 0x36, 0x9e, 0x6a, 0x21, 0x11, 0x71, 
	0xec, 0xb3, 0x7f, 0xd3, 0x32, 0xfe, 0x52, 0xf0, 0x5f, 0x3b, 
	0xd0, 0xb6, 0x3f, 0x75, 0xd2, 0x3f, 0x9e, 0xa7, 0xdb, 0xa7, 
	0x55, 0xf4, 0x82, 0x4a, 0x43, 0x8e, 0xf6, 0x86, 0x3d, 0x5d, 
	0x8f, 0xa0, 0x11, 0xfa, 0xd6, 0xb1, 0xcc, 0xbc, 0x48, 0x87, 
	0x3b, 0x5a, 0x08, 0xad
};


/*****************************************************************************/
void mydump(void* ptr,int len)
{
	int i, j;
	unsigned char c, *buf;
	unsigned int cc;

	j = 0;
	buf = ptr;
	for (i = 0; i < len; i++) {
		if (j > 15) {
			j = 0;
			printf("\n");
		}
		c = buf[i];
		cc = c;
		printf("%.2X ", cc);
		j++;
	}
	printf("\n");
}
/*****************************************************************************/
int main(int argc, char** argv)
{
	gostc_hash12_ctx_t hctx;
	int rc2 = 0;
	int rc = 1;
	uint8_t hash[64];
	uint8_t hash_gold[64];
	int i;

	rc2 = gostc_hash12_init(&hctx, 0);
	if (!rc2) rc2 = gostc_hash12_do(&hctx, HashIn, sizeof(HashIn));
	if (!rc2) rc2 = gostc_hash12_finish(&hctx, hash);
	if (rc2) {
		printf("hash error\n");
		goto end;
	}
	for (i = 0; i < 64; i++) hash_gold[i] = HashOut[63 - i];
	if (memcmp(hash, hash_gold, 64)) {
		printf("\nHASH MISMATCH!\n");
		printf("\nGolden:\n");
		mydump(hash_gold, 64);
		printf("\nCalculated:\n");
		mydump(hash, 64);
		goto end;
	}
	
	rc = 0;
end:
	if (rc) printf("\nTEST FAILED\n");
	else printf("\nTEST PASSED\n");
	return rc;
}

