#ifndef _P15INTERNAL_H_INCLUDED_
#define _P15INTERNAL_H_INCLUDED_

#ifdef TESTOUT
#include <stdio.h>
#endif


typedef struct p15_sbuf_t p15_sbuf_t;

struct p15_sbuf_t {
	p15_sbuf_t*	next;
	uint8_t*	ptr;
	size_t		len;
};


#ifdef __cplusplus
extern "C" {
#endif

extern p15_sbuf_t* p15_add_sbuf(p15_sbuf_t* root, const uint8_t* ptr, 
	size_t len);

extern void p15_free_sbuf(p15_sbuf_t**);
/* Frees the list */

extern int p15_get_solid_buf(p15_sbuf_t* inbuf, uint8_t** outbuf, size_t* outlen);
/* Allocates outbuf */


#ifdef TESTOUT
extern void p15_dump(void* buf, size_t len);
extern void p15_dump_mkey32(void* key, void* msk);
extern void p15_dump_id(p15_id_t* id);
extern void p15_print_key_usage(uint16_t ku);
extern void p15_print_key_access(uint8_t ka);
#endif

#ifdef __cplusplus
}
#endif


#endif

